/***************************************************************************\
	SMTP (Simple Mail Transfer Protocol) Example using EM1000
		Copyright (c) 1999, Z-World Engineering.

	The program allows a PK22xx to send eMail (via SMTP).

	The RS-232 serial port of the PK22xx (serial port Z0) should be connected to
	the COM1/RS232 port of the EM1000. This is easiest done with the Dynamic C
	Development cable (an RJ12 cable which plugs directly into the PK22xx and
	plugs into the EM1000 via Z-World's RJ12/DE9 adapter). Two additional lines
	need to be added. One connects ground of the PK22xx to ground of the EM1000.
	The other connection digital output 1 (HV01) to the CTL input of the EM1000.
	
	The function smtpInit should be called with:
		- Your eMail address
		- The name of your eMail server
		- The IP address of your eMail server

	The function smtpBegin should be called with:
		- The destination eMail address
		- The name of the destiny

	If smtpBegin returns true, a serial of emPrintf can be used to generate
	the body of the eMail. Lines are not terminated automatically, but can
	be terminated by sending a carriage return/linefeed pair (\r\n).

	Once you done generating eMail's body, call smtpEnd to terminate and
	send the message.
\***************************************************************************/

#use	"EM1000.LIB"

void
main				(	void
					)

{		emInit ();
		smtpInit ( "you@yourcompany.com","mail.yourcompany.com","10.10.10.10" );
		if (!smtpBegin ( "them@theircompany.com","Their Name" )) {
			printf ( "Unable to Open SMTP Port or Create SMTP header\n" );
		} else {
			emPrintf ( "This is the Body of the eMail!!!\r\n" );
			if (!smtpEnd ())
				printf ( "SMTP Not Sent\n" );
			else
				printf ( "SMTP Send Successfully\n" );
		}
}

