/***************************************************************************\
	Multi EM1000 Modem Application
		Copyright (c) 1999, Z-World Engineering

	A PK22xx controller controls one EM1000 which alternately sends serial
	messages to two other EM1000s.

	The two receiving EM1000s should be configured for passive listening via
	the LISTEN.BAT batch file. Make sure that each is configured with a unique
	IP address suitable for your network. Also make sure to modify the IP
	addresses in this program to match the ones you've selected.

	The master EM1000 should be configured minimally as follows (additional
	commands might be desired to control the flow of data from the master EM1000
	to the slave EM1000s):
		baud 19200
		configmode gpio
		connect request

	The RS-232 serial port of the PK22xx (serial port Z0) should be connected to
	the COM1/RS232 port of the EM1000. This is easiest done with the Dynamic C
	Development cable (an RJ12 cable which plugs directly into the PK22xx and
	plugs into the EM1000 via Z-World's RJ12/DE9 adapter). Two additional lines
	need to be added. One connects ground of the PK22xx to ground of the EM1000.
	The other connection digital output 1 (HV01) to the CTL input of the EM1000.

	If available, code for the PK22xx should be compiled and debugged using
	the XP8700 RS-232 Expansion Board for the PLCBus. If not available, simply
	downloading the code from the PC prior to switch the serial cable to the
	EM1000 should be sufficient.
\***************************************************************************/

#use	"EM1000.LIB"

void
send          (   char          *pcName,
                 unsigned       wCount
              )


{     if (emRemoteName ( pcName ))
         if (emOpen ()) {
          emDelay ( 500 );
          emPrintf ( "Count = %5u\r",wCount );
          emDelay ( 500 );
          emClose ();
         }
}




void
main				(	void
					)

{	unsigned		wCount;

		emInit ();
		for (wCount=0;;) {
			send ( "10.10.10.11",++wCount );
			send ( "10.10.10.12",++wCount );
		}
}
