/***************************************************************************\
	EtherNet Modem Example - Master
		Copyright (c) 1999, Me.
		9/28/99
\***************************************************************************/

#use		"VDRIVER.LIB"						//	Costates & Timers
#use		"AASCZ0.LIB"						//	Serial Port Z0

struct _Channel	*pZ0;						//	Z0 Handle

void
delay				(	unsigned long	qDelay
					)

{	unsigned long	qStart;

		for (qStart=MS_TIMER;MS_TIMER-qStart<qDelay;hitwd());
}

void
main				(	void
					)

{	static char		acR0[128];				//	Z0 Serial Buffers
	static char		acT0[128];
	char				acMsg[64];				//	Message Buffer
	char				*pcRep,acRep[64];		//	Reply Buffer
	unsigned			wCnt,wErr;				//	Message & Error Counts
	int				bTO;						//	Time Out Flag
	int				throw_away_mode;
		
		VdInit ();								//	Init Costates & Timers
		lcd_init ( 0x18 );					//	Init LCD
		lputc ( 0xF2 );						//	Cursor Off

		//	Init Z0 (RJ12) for 9600 N81
		
		pZ0 = aascOpen ( DEV_Z0,0,ASCI_PARAM_8N1+ASCI_PARAM_1200*16,NULL );
		aascSetReadBuf ( pZ0,acR0,sizeof(acR0) );
		aascSetWriteBuf ( pZ0,acT0,sizeof(acT0) );
		aascTxSwitch ( pZ0,1 );
		aascRxSwitch ( pZ0,1 );

		lprintf ( "\xFFWaiting for /CTS0" );
		while (IBIT ( CNTLB0,5 ))
			hitwd ();
		lputc ( 0xFF );
//		lprintf ( "\xFFStartup Delay" );
//		delay ( 5000 );

		wCnt = wErr = 0;						//	Zero Counters
		throw_away_mode = 0;
		for (;;) {								//	Forever
			costate {										//	Generate Message & Check Replies
				sprintf ( acMsg,"%03d",wCnt );			//	Generate Message w/ Zero Terminator
				if (throw_away_mode == 0)
					{
					waitfor ( aascWriteBlk(pZ0,acMsg,4,1) );
					++wCnt;
					}
				pcRep = acRep;									//	Init Reply Pointer
				do {												//	Wait for Next Serial Byte
					waitfor ( (bTO = DelayMs(1000)) || aascReadChar(pZ0,pcRep) );
				} while (!bTO && (*pcRep++ != '\0'));	//	Continue til Terminator Read
				*pcRep = 0;										//	Assure Termination
				if (strcmp(acMsg,acRep)!=0 )					// if the messages don't compare, stop writing until you read everything that's buffered up
					throw_away_mode = 1;
				if (bTO == 1)	// If a timeout occurs - there is no more buffered data to read, so start writing anew.
					throw_away_mode = 0;
				if (bTO || strcmp(acMsg,acRep))			//	Bump Error Count if Neccessary
					++wErr;
				if (wErr > 999) wErr = 999;
				lprintf ( "\xF0*%s* => *%s*",acMsg,acRep );
				lprintf ( "\xC0Errors %3d",wErr );
				if (999 <= wCnt)								//	Reset Counter @ 999
					wCnt = wErr = 0;
			}
			//	Other Costatements Here!!!
		}
}
